	.sect code,main
	.export _main


	//
	// Here is our main program that is called by the standard
	// startup routine. Of course, if our main code is written to
	// address 0 and no system functions are called, the startup
	// code doesn't necessarily have to be linked with it, but
	// then you need to allocate stack space and initialize the
	// stack pointer yourself.
_main:
	ldc readArea,i0		// Fill i0 with address readArea
	ldc writeArea,i1	// Fill i1 with address writeArea

	// Now we'll copy four words from i0 to i1. We'll also store
	// the intermediate results in internal registers so that they'll
	// be easy to look at with the simulator.

	// Note, that all commands on one line are executed in one single
	// clock cycle. See the processor core documentation for details on
	// what you may and what you may not put on the same line.

	ldx (i0)+1,a0			// If source and data are in different
	ldx (i0)+1,a1 ; sty a0,(i1)+1	// kinds of memory, pipelining may
	ldx (i0)+1,b0 ; sty a1,(i1)+1	// achieve very fast copy results.
	ldx (i0)+1,b1 ; sty b0,(i1)+1	// Here, 4 words are copied in 5 clock
			sty b1,(i1)+1	// cycles.

	// Now we'll use a loop to copy the next 15 words
	ldc 15-1,LS
	loop LS,loopEnd-1
	ldx (i0)+1,c0	// One delay slot after loop command, executed only
			//   once!
loopStart:
	sty c0,(i1)+1; ldx (i0)+1,c0	// One cycle copy loop
loopEnd:
	sty c0,(i1)+1	// The 16'th word is copied here by hand

endOfLine:
	j 0xFFFF	// Bad address to stop simulator
	nop		// Jumps's delay slot





	.sect data_x,const_x	// X Memory data area
	.export readArea	// Without this, we couldn't see the address in
				//   the simulator
readArea:
	.uword 0xface, 0xcafe, 0xcace, 0x1234
	.uword 1, 2, 3, 4, 5, 6, 12345, 13131
	.uword 0x1111, 0x2222, 0x3333, 0x4444, 0x5555, 0x6666, 0x7777, 0x8888

	.sect data_y,data_Y	// Y Memory data area
	.export writeArea
writeArea:
	.bss 4
	.bss 16

	// The .end directive is needed to tell the compiler that the
	// source file is intact. After the directive anything can be
	// written.
	.end
